// Copyright (C) 2001 Eric Hanchrow
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Eric Hanchrow -- offby1@blarg.net
// 1914 N. 40th
// Seatlle, WA, USA
// 98103-8310
#include <iostream>
#include "card.hh"

std::ostream & operator<< (std::ostream &o, const rank &r)
{
  switch (r)
    {
    case two:   o << "two";   break;
    case three: o << "three"; break;
    case four:  o << "four";  break;
    case five:  o << "five";  break;
    case six:   o << "six";   break;
    case seven: o << "seven"; break;
    case eight: o << "eight"; break;
    case nine:  o << "nine";  break;
    case ten:   o << "ten";   break;
    case jack:  o << "jack";  break;
    case queen: o << "queen"; break;
    case king:  o << "king";  break;
    case ace:   o << "ace";   break;
    default:
      assert (0);
    }

  return o;
}

std::ostream & operator<< (std::ostream &o, const suit &s)
{
  switch (s)
    {
    case clubs   : o << "clubs"   ; break;
    case diamonds: o << "diamonds"; break;
    case hearts  : o << "hearts"  ; break;
    case spades  : o << "spades"  ; break;
    default:
      assert (0);
    }
  return o;
}

std::ostream & operator<< (std::ostream &o, const card &c)
{
  o << c.get_rank ()
    << " of "
    << c.get_suit ();

  return o;
}

unsigned short card::get_HCP () const
{
  return (_r - 10 > 0
          ? _r - 10
          : 0);
}
