// Copyright (C) 2001 Eric Hanchrow
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Eric Hanchrow -- offby1@blarg.net
// 1914 N. 40th
// Seatlle, WA, USA
// 98103-8310
#ifndef FILE_CONTRACT_SEEN
#define FILE_CONTRACT_SEEN

#include "call.hh"
#include "compass.hh"

class contract
{
public:
  enum multiplier
    {
      not_doubled = 0, doubled, redoubled
    };

private:
  bid        _bid;
  seat       _declarer;
  multiplier _mult;

public:
  contract (const bid &b,
            const seat &d,
            const multiplier &m)
    :_bid(b),
     _declarer (d),
     _mult (m)
  {}

  bid        get_bid        () const { return _bid                ; }
  seat       get_declarer   () const { return _declarer           ; }
  multiplier get_multiplier () const { return _mult               ; }

  friend std::ostream & operator<<(std::ostream &o, const contract &c);
  friend std::ostream & operator<<(std::ostream &o, const multiplier &m);
};

#endif  /* FILE_CONTRACT_SEEN */
