// Copyright (C) 2001 Eric Hanchrow
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Eric Hanchrow -- offby1@blarg.net
// 1914 N. 40th
// Seatlle, WA, USA
// 98103-8310
#ifndef FILE_UGLY_MACROS_SEEN
#define FILE_UGLY_MACROS_SEEN

// I'd like to find a way to do this without using the preprocessor.

// Note that you mustn't call CPPUNIT_ASSERT_MESSAGE inside the `try',
// because it ... ahem ... throws an exception.


#define CHECK_FOR_EXCEPTION(expected_exception_type, thunk)             \
{                                                                       \
  bool f_got_exception = true;                                          \
  try                                                                   \
    {                                                                   \
      (thunk);                                                          \
      f_got_exception = false;                                          \
    }                                                                   \
  catch (expected_exception_type &e)                                    \
    {                                                                   \
      CPPUNIT_ASSERT_MESSAGE ("got the right exception",                \
                              true);                                    \
    }                                                                   \
  catch (std::exception &e)                                             \
    {                                                                   \
      std::string message = "got the wrong exception:";                 \
      message += e.what();                                              \
      message += " (expected ";                                         \
      message += #expected_exception_type;                              \
      message += ")";                                                   \
      CPPUNIT_ASSERT_MESSAGE (message,                                  \
                              false);                                   \
    }                                                                   \
  catch (...)                                                           \
    {                                                                   \
      CPPUNIT_ASSERT_MESSAGE ("got totally unexpected exception",       \
                              false);                                   \
    }                                                                   \
                                                                        \
  if (!f_got_exception)                                                 \
    {                                                                   \
      CPPUNIT_ASSERT_MESSAGE ("should have gotten an exception",        \
                              false);                                   \
    }                                                                   \
}

#define CHECK_FOR_NO_EXCEPTION(thunk)                                   \
    try                                                                 \
      {                                                                 \
        (thunk);                                                        \
        CPPUNIT_ASSERT_MESSAGE ("should not have gotten an exception",  \
                                true);                                  \
      }                                                                 \
    catch (std::exception &e)                                           \
    {                                                                   \
      std::string message = "got a std::exception: `";                  \
      message += e.what();                                              \
      message += "'";                                                   \
      CPPUNIT_ASSERT_MESSAGE (message, false);                          \
    }                                                                   \
    catch (...)                                                         \
      {                                                                 \
        CPPUNIT_ASSERT_MESSAGE ("got an exception",                     \
                                false);                                 \
      }
#endif
