// Copyright (C) 2001 Eric Hanchrow
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Eric Hanchrow -- offby1@blarg.net
// 1914 N. 40th
// Seatlle, WA, USA
// 98103-8310
#ifndef FILE_TEXT_PLAYER_SEEN
#define FILE_TEXT_PLAYER_SEEN

#include <vector>
#include "../hand.hh"
#include "../auction.hh"
#include "../card.hh"
#include "../trick.hh"
#include "../compass.hh"
#include "../score.hh"
#include "../player.hh"

class text_player : public player
{
public:
  /// The return value was allocated with `new', so `delete' it when
  /// you're done.
  call *make_call (const seat &who_am_i,
                   const auction &so_far,
                   const rubber_scoresheet &score);

  /// Decide which card to play to this trick.
  card choose_card (const auction &,
                    const rubber_scoresheet &,
                    const plays &,
                    const std::vector<card> &current_trick,
                    const hand *dummy // will be 0 for opening lead
                    );
};

#endif
