// Copyright (C) 2001 Eric Hanchrow
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Eric Hanchrow -- offby1@blarg.net
// 1914 N. 40th
// Seatlle, WA, USA
// 98103-8310
#ifndef FILE_PLAYS_SEEN
#define FILE_PLAYS_SEEN

#include <vector>
#include <cassert>
#include "card.hh"
#include "compass.hh"
#include "call.hh"

/// A history of all the cards that have been played this hand.

class trick
{
  trick ();
  std::vector<card> _cards;
  seat _leader;
  seat _winner;
  void determine_winner (const denomination &trump_suit);

public:
  /// Calculates the winner.  asserts ( cards.size ()  = 4)
  trick (const seat &leader,
         const denomination &trump_suit,
         const std::vector<card> &cards)
    : _cards (cards),
      _leader (leader)
  {
    assert (cards.size () == 4);
    determine_winner (trump_suit);
  }

  const seat & leader () const { return _leader; }
  const seat & winner () const { return _winner; }

  const std::vector<card> & cards () const { return _cards; }

  friend std::ostream & operator<<(std::ostream &o, const trick &t);
};

typedef std::vector<trick>  plays;

#endif  /* FILE_PLAYS_SEEN */
